package com.infinitegraph.samples.webgroup;

//Import InfiniteGraph packages
import java.net.URL;
import java.util.Calendar;
import java.util.Collections;
import java.util.Map;
import java.util.TreeMap;
import java.util.Vector;

import com.infinitegraph.*;
import com.infinitegraph.navigation.*;
import com.infinitegraph.navigation.policies.*;
import com.infinitegraph.navigation.qualifiers.*;
import com.infinitegraph.policies.PolicyChain;

//Import SLF4J logging packages
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class WebGroupSampleRun {
	  static Logger logger = null;      // Set up logging
	  
	  public static Logger getLogger() 
	  {
	    if (logger == null)
	      logger = LoggerFactory.getLogger(WebGroupSampleRun.class);
	    return logger;
	  }

	  public boolean CreateMemberNode(String MemberName, String password) 
	  {
	    Transaction tx = null;      // Handle for the transaction
	    boolean find =false;
	    // Name of the existing graph and properties file, handle for graph
	    String graphDbName = "WebGroupSample";
	    String propertiesFileName = "/config/Relations.properties";
	    GraphDatabase WebGroupSampleDB = null;
	    URL url = getClass().getResource(propertiesFileName);
	    try {
	    	 WebGroupSampleDB = GraphFactory.open(graphDbName, url.getPath()); // Open the graph
	    	 WebGroupSampleRun.getLogger().info("> Starting an update transaction ...");
		     tx = WebGroupSampleDB.beginTransaction(AccessMode.READ_WRITE);
		     Person user = (Person)WebGroupSampleDB.getNamedVertex(MemberName);
		      // Create vertices and add them to the graph.
		      // Members
		     System.out.println(password);
		     if(user==null){
		      find=false;
		      WebGroupSampleCreate.getLogger().info("> Creating Node ...");
		      Person newPerson = new Person(MemberName, password);
		      WebGroupSampleDB.addVertex(newPerson);
		      WebGroupSampleDB.nameVertex(MemberName, newPerson);
		      WebGroupSampleCreate.getLogger().info("> Node Created ...");
		      
		     
		     }
		     else
		     {
		    	 find=true;
		     }
		     
		      // Commit the changes to the graph database
		      tx.commit();
		      WebGroupSampleCreate.getLogger().info("> Committed changes ...");
		    } 
		    catch (Exception e) 
		    {
		      WebGroupSampleCreate.getLogger().info("> Exception in createGraphData: " + e.getMessage());
		      e.printStackTrace();
		      tx.rollback();
		    } 
		    finally 
		    {
		      tx.complete();
		      WebGroupSampleCreate.getLogger().info("> Finished completing transaction ...");
		    }
	    return find;
	  }
	  public boolean ExistMemberNode(String MemberName, String password) 
	  {
	    Transaction tx = null;      // Handle for the transaction
	    boolean find =false;
	    // Name of the existing graph and properties file, handle for graph
	    String graphDbName = "WebGroupSample";
	    String propertiesFileName = "/config/Relations.properties";
	    GraphDatabase WebGroupSampleDB = null;
	    URL url = getClass().getResource(propertiesFileName);
	    try {
	    	 WebGroupSampleDB = GraphFactory.open(graphDbName, url.getPath()); // Open the graph
	    	 WebGroupSampleRun.getLogger().info("> Starting an update transaction ...");
		     tx = WebGroupSampleDB.beginTransaction(AccessMode.READ_WRITE);
		     Person user = (Person)WebGroupSampleDB.getNamedVertex(MemberName);
		     
		     if(user!=null && user.getPassword().equals(password)){
		    	 find=false;
		     }
		     else
		     {
		    	 find=true;
		     }
		     
		      // Commit the changes to the graph database
		      tx.commit();
		      WebGroupSampleCreate.getLogger().info("> Committed changes ...");
		    } 
		    catch (Exception e) 
		    {
		      WebGroupSampleCreate.getLogger().info("> Exception in createGraphData: " + e.getMessage());
		      e.printStackTrace();
		      tx.rollback();
		    } 
		    finally 
		    {
		      tx.complete();
		      WebGroupSampleCreate.getLogger().info("> Finished completing transaction ...");
		    }
	    return find;
	  }
	  public void CreateStatusNode(String memberName, String status) 
	  {
	    Transaction tx = null;      // Handle for the transaction

	    // Name of the existing graph and properties file, handle for graph
	    String graphDbName = "WebGroupSample";
	    String propertiesFileName = "/config/Relations.properties";
	    GraphDatabase WebGroupSampleDB = null;
	    URL url = getClass().getResource(propertiesFileName);
	    try {
	    	 WebGroupSampleDB = GraphFactory.open(graphDbName, url.getPath()); // Open the graph
	    	 WebGroupSampleRun.getLogger().info("> Starting an update transaction ...");
		     tx = WebGroupSampleDB.beginTransaction(AccessMode.READ_WRITE);

		     WebGroupSampleCreate.getLogger().info("> Creating vertices ...");
		     		      
		     Calendar dateTime = Calendar.getInstance();		    
		     
		      Status newStatus = new Status(status);
		      WebGroupSampleDB.addVertex(newStatus);
		     
		      // Name some root vertices (for searching)
		     
		     
		      Write newPost = new Write(dateTime);    

		      
		      // Create connections
		     System.out.println(memberName);
		      WebGroupSampleCreate.getLogger().info("> Connecting vertices ...");
		     Person currentMember = (Person)WebGroupSampleDB.getNamedVertex(memberName);
		    //  System.out.println(currentMember.getName());
		      currentMember.addEdge(newPost, newStatus, EdgeKind.OUTGOING, (short) 1);
		     
		      WebGroupSampleCreate.getLogger().info("> Finished creating vertices ...");

		      // Commit the changes to the graph database
		      tx.commit();
		      WebGroupSampleCreate.getLogger().info("> Committed changes ...");
		    } 
		    catch (Exception e) 
		    {
		      WebGroupSampleCreate.getLogger().info("> Exception in createGraphData: " + e.getMessage());
		      e.printStackTrace();
		      tx.rollback();
		    } 
		    finally 
		    {
		      tx.complete();
		      WebGroupSampleCreate.getLogger().info("> Finished completing transaction ...");
		    }
	  }
	  public String checkFriend(String userName, String friendName) 
	  {
	    Transaction tx = null;      // Handle for the transaction

	    // Name of the existing graph and properties file, handle for graph
	    String graphDbName = "WebGroupSample";
	    String propertiesFileName = "/config/Relations.properties";
	    GraphDatabase WebGroupSampleDB = null;
	    URL url = getClass().getResource(propertiesFileName);
	    Person friend=null;
	    checkFriendResultsHandler friendCheckHandler=null;
	    	 try {
				WebGroupSampleDB = GraphFactory.open(graphDbName, url.getPath());
			
	    	 WebGroupSampleRun.getLogger().info("> Starting an update transaction ...");
		     tx = WebGroupSampleDB.beginTransaction(AccessMode.READ_WRITE);

		     WebGroupSampleCreate.getLogger().info("> Creating vertices ...");
		     		      
		     
		     
		    friend = (Person)WebGroupSampleDB.getNamedVertex(friendName);
		    Person user = (Person)WebGroupSampleDB.getNamedVertex(userName);
		    friendCheckHandler = new checkFriendResultsHandler();
	    	PolicyChain myPolicies = new PolicyChain(new MaximumPathDepthPolicy(1));
	    	VertexIdentifier myVertexId = new VertexIdentifier(friend);
		    Navigator myNavigator = user.navigate(null, Guide.SIMPLE_DEPTH_FIRST, Qualifier.FOREVER, myVertexId, myPolicies, friendCheckHandler);

		      // Perform the navigation
		      myNavigator.start();
		      myNavigator.stop();
		    tx.commit();
		      WebGroupSampleCreate.getLogger().info("> Committed changes ...");
		    } 
		    catch (Exception e) 
		    {
		      WebGroupSampleCreate.getLogger().info("> Exception in createGraphData: " + e.getMessage());
		      e.printStackTrace();
		      tx.rollback();
		    } 
		    finally 
		    {
		      tx.complete();
		      WebGroupSampleCreate.getLogger().info("> Finished completing transaction ...");
		     
		    }
	    	 if(friend==null )
			    	return "NO";
			 else if(friend!=null && friendCheckHandler.find==false)
			    	return "YES";
			 else
				 return "Friend";
		     
	  }
	  public void AddFriend(String userName, String friendName) 
	  {
	    Transaction tx = null;      // Handle for the transaction

	    // Name of the existing graph and properties file, handle for graph
	    String graphDbName = "WebGroupSample";
	    String propertiesFileName = "/config/Relations.properties";
	    GraphDatabase WebGroupSampleDB = null;
	    URL url = getClass().getResource(propertiesFileName);
	    try {
	    	 WebGroupSampleDB = GraphFactory.open(graphDbName, url.getPath()); // Open the graph
	    	 WebGroupSampleRun.getLogger().info("> Starting an update transaction ...");
		     tx = WebGroupSampleDB.beginTransaction(AccessMode.READ_WRITE);

		     WebGroupSampleCreate.getLogger().info("> Creating vertices ...");
		     		      
		    
		     Friendship newFriend = new Friendship();
		      
		   
		     Person user = (Person)WebGroupSampleDB.getNamedVertex(userName);
		     System.out.println(userName);
		     System.out.println(friendName);
		     
		     Person friend = (Person)WebGroupSampleDB.getNamedVertex(friendName);
		    
		    System.out.println(friend.getName());
		     user.addEdge(newFriend, friend, EdgeKind.BIDIRECTIONAL, (short) 0);
		     
		      WebGroupSampleCreate.getLogger().info("> Finished creating vertices ...");

		      // Commit the changes to the graph database
		      tx.commit();
		      WebGroupSampleCreate.getLogger().info("> Committed changes ...");
		    } 
		    catch (Exception e) 
		    {
		      WebGroupSampleCreate.getLogger().info("> Exception in createGraphData: " + e.getMessage());
		      e.printStackTrace();
		      tx.rollback();
		    } 
		    finally 
		    {
		      tx.complete();
		      WebGroupSampleCreate.getLogger().info("> Finished completing transaction ...");
		    }
	  }
	  @SuppressWarnings("finally")
	public Map FindPosts(String userName) 
	  {
	    Transaction tx = null;      // Handle for the transaction

	    // Name of the existing graph and properties file, handle for graph
	    String graphDbName = "WebGroupSample";
	    String propertiesFileName = "/config/Relations.properties";
	    GraphDatabase WebGroupSampleDB = null;
	    URL url = getClass().getResource(propertiesFileName);
	    PrintPathResultsHandler resultPrinter = null;
	    try {
	    	 WebGroupSampleDB = GraphFactory.open(graphDbName, url.getPath()); // Open the graph
	    	 tx = WebGroupSampleDB.beginTransaction(AccessMode.READ_WRITE);
	    	 long statusId = WebGroupSampleDB.getTypeId("com.infinitegraph.samples.webgroup.Status");
	    	 System.out.println(statusId);
	    	 resultPrinter = new PrintPathResultsHandler(statusId);
	    	 //GraphView myGraphView = new GraphView();
		      //myGraphView.excludeClass(WebGroupSampleDB.getTypeId(InstantChat.class.getName()));
		      // HINT: Add policies here    
		      PolicyChain myPolicies = new PolicyChain(new MaximumPathDepthPolicy(2));
		      // HINT: Add navigation/qualification code here.
		      Person user = (Person)WebGroupSampleDB.getNamedVertex(userName);
		      // Create navigator
		      VertexTypes statusVertexType= new VertexTypes(WebGroupSampleDB.getTypeId("com.infinitegraph.samples.webgroup.Status"));
		      //Member john = (Member)WebGroupSampleDB.getNamedVertex("John");
		      //VertexIdentifier myVertexId = new VertexIdentifier(john);
		      Navigator myNavigator = user.navigate(null, Guide.SIMPLE_DEPTH_FIRST, Qualifier.FOREVER, statusVertexType, myPolicies, resultPrinter);

		      // Perform the navigation
		      myNavigator.start();
		      myNavigator.stop();
		      // Commit the changes to the graph database
		      tx.commit();
		      WebGroupSampleCreate.getLogger().info("> Committed changes ...");
		    } 
		    catch (Exception e) 
		    {
		      WebGroupSampleCreate.getLogger().info("> Exception in createGraphData: " + e.getMessage());
		      e.printStackTrace();
		      tx.rollback();
		    } 
		    finally 
		    {
		      tx.complete();
		      WebGroupSampleCreate.getLogger().info("> Finished completing transaction ...");
		      return resultPrinter.treeMap;
		    }
	  }
	  public Vector FindFriends(String userName) 
	  {
	    Transaction tx = null;      // Handle for the transaction

	    // Name of the existing graph and properties file, handle for graph
	    String graphDbName = "WebGroupSample";
	    String propertiesFileName = "/config/Relations.properties";
	    GraphDatabase WebGroupSampleDB = null;
	    URL url = getClass().getResource(propertiesFileName);
	    FriendResultsHandler friendPrinter = null;
	    try {
	    	 WebGroupSampleDB = GraphFactory.open(graphDbName, url.getPath()); // Open the graph
	    	 tx = WebGroupSampleDB.beginTransaction(AccessMode.READ_WRITE);
	    	 long statusId = WebGroupSampleDB.getTypeId("com.infinitegraph.samples.webgroup.Person");
	    	 friendPrinter = new FriendResultsHandler(statusId);
	    	 PolicyChain myPolicies = new PolicyChain(new MaximumPathDepthPolicy(1));
	    	 System.out.println("hiiiiiiiiiiiii");
		     Person user = (Person)WebGroupSampleDB.getNamedVertex(userName);
		      // Create navigator
		      VertexTypes statusVertexType= new VertexTypes(WebGroupSampleDB.getTypeId("com.infinitegraph.samples.webgroup.Person"));
		      //Member john = (Member)WebGroupSampleDB.getNamedVertex("John");
		      //VertexIdentifier myVertexId = new VertexIdentifier(john);
		      Navigator myNavigator = user.navigate(null, Guide.SIMPLE_DEPTH_FIRST, Qualifier.FOREVER, statusVertexType, myPolicies, friendPrinter);

		      // Perform the navigation
		      myNavigator.start();
		      myNavigator.stop();
		      // Commit the changes to the graph database
		      tx.commit();
		      WebGroupSampleCreate.getLogger().info("> Committed changes ...");
		    } 
		    catch (Exception e) 
		    {
		      WebGroupSampleCreate.getLogger().info("> Exception in createGraphData: " + e.getMessage());
		      e.printStackTrace();
		      tx.rollback();
		    } 
		    finally 
		    {
		      tx.complete();
		      WebGroupSampleCreate.getLogger().info("> Finished completing transaction ...");
		      return friendPrinter.friends;
		    }
	  }
	  	  
}
	  	  

class PrintPathResultsHandler implements NavigationResultHandler 
{
	public Map<Calendar, PostInfo> treeMap;
    private Logger logger = null;
    long statusId;
    PrintPathResultsHandler(long statusId)
    {
    	this.treeMap = new TreeMap<Calendar, PostInfo>(Collections.reverseOrder());
    	this.statusId = statusId;
	logger = LoggerFactory.getLogger(PrintPathResultsHandler.class);
    }
    @Override
    public void handleResultPath(Path result, Navigator navigator) {
		
	logger.info("FOUND MATCHING PATH: ");
	String path = result.get(0).getVertex().toString();
	Person person = (Person)result.get(0).getVertex();
	// For h in p
        for(Hop h : result)
        {
            if(h.hasEdge())
            {
            	System.out.println(h.getVertex().getTypeId());
            	System.out.println(statusId);
            	if(h.getVertex().getTypeId()==statusId){
	            	Status status = (Status)h.getVertex();
					Write post = (Write)h.getEdge();
					PostInfo postInfo = new PostInfo(person.getName(), status.getMessage());
					treeMap.put(post.getTimeStamp(), postInfo);
            	}
            	else
            	{
            		person = (Person)h.getVertex();
            	}
            	path = path + " < " + h.getEdge().toString() + " > " + h.getVertex().toString();
            } 
        }
        logger.info("{}", path);
    }
    @Override
    public void handleNavigatorFinished(Navigator navigator) {}
}

class FriendResultsHandler implements NavigationResultHandler 
{
	public Vector friends = new Vector();
    private Logger logger = null;
    long statusId;
    FriendResultsHandler(long statusId)
    {
    	this.statusId = statusId;
	logger = LoggerFactory.getLogger(PrintPathResultsHandler.class);
    }
    @Override
    public void handleResultPath(Path result, Navigator navigator) {
		
	logger.info("FOUND MATCHING PATH: ");
	String path = result.get(0).getVertex().toString();
	
	// For h in p
        for(Hop h : result)
        {
            if(h.hasEdge())
            {
            	
            	if(h.getVertex().getTypeId()==statusId){
	            	Person person = (Person)h.getVertex();
					friends.add(person.getName());
            	}
            	path = path + " < " + h.getEdge().toString() + " > " + h.getVertex().toString();
            } 
        }
        logger.info("{}", path);
    }
    @Override
    public void handleNavigatorFinished(Navigator navigator) {}
}
class checkFriendResultsHandler implements NavigationResultHandler 
{
	public boolean find=false;
    private Logger logger = null;
    
    checkFriendResultsHandler()
    {
    	
	logger = LoggerFactory.getLogger(PrintPathResultsHandler.class);
    }
    @Override
    public void handleResultPath(Path result, Navigator navigator) {
		
	logger.info("FOUND MATCHING PATH: ");
	String path = result.get(0).getVertex().toString();
	
	// For h in p
        for(Hop h : result)
        {
            if(h.hasEdge())
            {
            	 this.find=true;
            	 path = path + " < " + h.getEdge().toString() + " > " + h.getVertex().toString();
                 
            }
            	
        }
        logger.info("{}", path);
    }
    @Override
    public void handleNavigatorFinished(Navigator navigator) {}
}